// 	WOSA/XRT Excel 5.0 AddIn Version 1.00
//
//	COPYRIGHT:
//
//  	(C) Copyright Microsoft Corp. 1994.  All rights reserved.
//
//   	You have a royalty-free right to use, modify, reproduce and
//   	distribute the Sample Files (and/or any modified version) in
//   	any way you find useful, provided that you agree that
//   	Microsoft has no warranty obligations or liability for any
//   	Sample Application Files which are modified.
//
//
// 	Revision History
//    	October 15, 1994   rc    Version 1.00 Release

class CProperties;

class FAR CRequest : public _IRequest
{

friend CRequests;
friend CCache;

public:		
   	STDMETHOD(QueryInterface)(REFIID riid, LPVOID FAR* ppvObj);
   	STDMETHOD_(ULONG, AddRef)();
   	STDMETHOD_(ULONG, Release)();

    // IDispatch methods 
    STDMETHOD(GetTypeInfoCount)(UINT FAR* pctinfo);
    STDMETHOD(GetTypeInfo)(UINT itinfo, LCID lcid, ITypeInfo FAR* FAR* pptinfo);
    STDMETHOD(GetIDsOfNames)(REFIID riid, OLECHAR FAR* FAR* rgszNames,
    	UINT cNames, LCID lcid, DISPID FAR* rgdispid);
    STDMETHOD(Invoke)(DISPID dispidMember, REFIID riid, LCID lcid,
      	WORD wFlags,DISPPARAMS FAR* pdispparams, VARIANT FAR* pvarResult,
      	EXCEPINFO FAR* pexcepinfo, UINT FAR* puArgErr);
    STDMETHOD_(IDispatch *, get_Properties)(void);
    STDMETHOD_(BSTR, get_Request)(void);
    STDMETHOD_(void, put_Request)(BSTR newvalue);
    STDMETHOD_(IDispatch *, get_Object)(void);
                                                           
    static HRESULT Create(BSTR bstrName, CRequest FAR* FAR* ppRequest) ; // Creates and intializes Item.
    CRequest();
    ~CRequest();

private:
	HRESULT XRTProperties(LPDISPATCH FAR *ppDispatch);

private:
	LPDISPATCH 				m_dispProperties;
	BSTR					m_bstrSymbolName;
	CProperties FAR *		m_pProperties;
	LPDISPATCH 				m_pXRTDispatch;
	LPXLOPER 				m_pxlRequest;
	CDataObject FAR *		m_pDataObject;
	DWORD					m_dwIndex;
	DWORD					m_dwRequestID;
	CRequests FAR *			m_pRequests;
	BSTR					m_bstrPassThroughFunc;
	BSTR					m_bstrName;
	LPTYPEINFO				m_ptinfo;
	ULONG					m_cRef;
   	EXCEPINFO 				m_excepinfo;      	// Information to raise an exception on error.
   	BOOL 					m_bRaiseException;	// Properties and methods use this to signal an exception to be raised.
};

