// xrtobj32.h
//
// XRTOBJ32 is a sample application that illustrates how to build
// a simple IDataObject centric OLE 2.0 object.  
//
// Copyright (c) 1993 Microsoft Corporation, All Rights Reserved.
//
// WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
//
// WARNING: This sample does not support the REAL WOSA/XRT
//          specification!   It is an early prototype that is
//          included in the SDK because it illustrates how
//          to do Uniform Data Transfer without using MFC.
//
//          This sample DOES NOT support Version 1.0 of the
//          WOSA/XRT Design Specification.  It does not
//          use the real WOSA/XRT Clipboard format.
//          It does not implement the WOSA/XRT Programmability
//          Interface (in fact it doesn't even support IDispatch).
//
//          Use this sample to learn about Uniform Data Transfer
//          (IDataObject and IAdviseSink).
//
// WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
//
// See README.TXT for more info.

#ifndef _XRTOBJ32_H_
#define _XRTOBJ32_H_

extern HINSTANCE   g_hInst ;
extern HWND        g_hwndMain ;
extern LPTSTR      g_pszCmdLine ;

// Class factory related globals
extern LPCLASSFACTORY  g_pIClassFactory ;
extern DWORD           g_cLock ;              // Lock count
extern DWORD           g_cObj ;               // Number of alive objects
extern DWORD           g_dwRegCO ;

// Simulation globals
class CSimulation ;
extern CSimulation*    g_pSimObj ;
extern UINT            g_uiTimeoutMarket ;
extern UINT            g_uiTimeoutUpdate ;

class CStocksObject ;
void WINAPI ObjectCreated( CStocksObject* pObj, BOOL fCreated )  ;
typedef void (CALLBACK* PFNCREATED)( CStocksObject*, BOOL ) ;


/////////////////////////////////////////////////////////////////////////////
// IClassFactory implementation class
//
class FAR CImpIClassFactory : public IClassFactory
{
protected:
    ULONG           m_cRef;         //Reference count on object

public:
    CImpIClassFactory(void);
    ~CImpIClassFactory(void);

    //IUnknown interface members
    STDMETHODIMP QueryInterface(REFIID, LPVOID FAR *);
    STDMETHODIMP_(ULONG) AddRef(void);
    STDMETHODIMP_(ULONG) Release(void);

    //IClassFactory members
    STDMETHODIMP CreateInstance(LPUNKNOWN, REFIID, LPVOID FAR *);
    STDMETHODIMP LockServer(BOOL);
};


#endif // _XRTOBJ32_H_
